local WodHMId, WodBRFId, WodHFCId = 994, 988, 1026
local RaidDiffcultyNormal, RaidDiffcultyHeroic, RaidDiffcultyMythic = "Normal", "Heroic", "Mythic"

function LoadSavedOptions()
	if (HungryRaidDB == nil) then
		CreateDatabase()
	end
	
	chkHM:SetChecked(HungryRaidDB["options"][WodHMId].Selected)
	chkHMNormal:SetChecked(HungryRaidDB["options"][WodHMId][RaidDiffcultyNormal])
	chkHMHeroic:SetChecked(HungryRaidDB["options"][WodHMId][RaidDiffcultyHeroic])
	chkHMMythic:SetChecked(HungryRaidDB["options"][WodHMId][RaidDiffcultyMythic])

	chkBRF:SetChecked(HungryRaidDB["options"][WodBRFId].Selected)
	chkBRFNormal:SetChecked(HungryRaidDB["options"][WodBRFId][RaidDiffcultyNormal])
	chkBRFHeroic:SetChecked(HungryRaidDB["options"][WodBRFId][RaidDiffcultyHeroic])
	chkBRFMythic:SetChecked(HungryRaidDB["options"][WodBRFId][RaidDiffcultyMythic])

	chkHFC:SetChecked(HungryRaidDB["options"][WodHFCId].Selected)
	chkHFCNormal:SetChecked(HungryRaidDB["options"][WodHFCId][RaidDiffcultyNormal])
	chkHFCHeroic:SetChecked(HungryRaidDB["options"][WodHFCId][RaidDiffcultyHeroic])
	chkHFCMythic:SetChecked(HungryRaidDB["options"][WodHFCId][RaidDiffcultyMythic])
	
	chkFlasks:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Flasks"].Selected)
	txtFlasksEPValue:SetNumber(HungryRaidDB["options"]["HungryRaid"]["Flasks"].EPValue)
	
	chkFoods:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected)
	chkFoods100:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected100)
	chkFoods125:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected125)
	txtFoodsEPValue:SetNumber(HungryRaidDB["options"]["HungryRaid"]["Foods"].EPValue)

	chkPotions:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Potions"].Selected)
	txtPotionsEPValue:SetNumber(HungryRaidDB["options"]["HungryRaid"]["Potions"].EPValue)

	chkPrePotions:SetChecked(HungryRaidDB["options"]["HungryRaid"]["PrePotions"].Selected)
	txtPrePotionsEPValue:SetNumber(HungryRaidDB["options"]["HungryRaid"]["PrePotions"].EPValue)

	chkRunes:SetChecked(HungryRaidDB["options"]["HungryRaid"]["Runes"].Selected)
	txtRunesEPValue:SetNumber(HungryRaidDB["options"]["HungryRaid"]["Runes"].EPValue)
	
	txtRunesEPValue:SetFocus()
	txtRunesEPValue:ClearFocus()
	
end

function CreateDatabase()
	if (EPGPConsumablesDB) then
		HungryRaidDB = EPGPConsumablesDB
	else
		HungryRaidDB = {}
		HungryRaidDB["options"] = {}
		HungryRaidDB["options"][WodHMId] = {}
		HungryRaidDB["options"][WodHMId].Id = 994
		HungryRaidDB["options"][WodHMId].Selected = true
		HungryRaidDB["options"][WodHMId][RaidDiffcultyNormal] = true
		HungryRaidDB["options"][WodHMId][RaidDiffcultyHeroic] = true
		HungryRaidDB["options"][WodHMId][RaidDiffcultyMythic] = true
		HungryRaidDB["options"][WodBRFId] = {}
		HungryRaidDB["options"][WodBRFId].Id = 988
		HungryRaidDB["options"][WodBRFId].Selected = true
		HungryRaidDB["options"][WodBRFId][RaidDiffcultyNormal] = true
		HungryRaidDB["options"][WodBRFId][RaidDiffcultyHeroic] = true
		HungryRaidDB["options"][WodBRFId][RaidDiffcultyMythic] = true
		HungryRaidDB["options"][WodHFCId] = {}
		HungryRaidDB["options"][WodHFCId].Id = 1026
		HungryRaidDB["options"][WodHFCId].Selected = true
		HungryRaidDB["options"][WodHFCId][RaidDiffcultyNormal] = true
		HungryRaidDB["options"][WodHFCId][RaidDiffcultyHeroic] = true
		HungryRaidDB["options"][WodHFCId][RaidDiffcultyMythic] = true

		HungryRaidDB["options"]["HungryRaid"] = {}
		HungryRaidDB["options"]["HungryRaid"]["Flasks"] = {}
		HungryRaidDB["options"]["HungryRaid"]["Flasks"].Selected = true
		HungryRaidDB["options"]["HungryRaid"]["Flasks"].EPValue = 5
		
		HungryRaidDB["options"]["HungryRaid"]["Foods"] = {}
		HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected = true
		HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected100 = false
		HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected125 = true
		HungryRaidDB["options"]["HungryRaid"]["Foods"].EPValue = 5

		HungryRaidDB["options"]["HungryRaid"]["Potions"] = {}
		HungryRaidDB["options"]["HungryRaid"]["Potions"].Selected = true
		HungryRaidDB["options"]["HungryRaid"]["Potions"].EPValue = 5

		HungryRaidDB["options"]["HungryRaid"]["PrePotions"] = {}
		HungryRaidDB["options"]["HungryRaid"]["PrePotions"].Selected = true
		HungryRaidDB["options"]["HungryRaid"]["PrePotions"].EPValue = 5

		HungryRaidDB["options"]["HungryRaid"]["Runes"] = {}
		HungryRaidDB["options"]["HungryRaid"]["Runes"].Selected = true
		HungryRaidDB["options"]["HungryRaid"]["Runes"].EPValue = 5
	end
end

function SaveOptions()
	HungryRaidDB["options"][WodHMId].Selected = chkHM:GetChecked()
	HungryRaidDB["options"][WodHMId][RaidDiffcultyNormal] = chkHMNormal:GetChecked()
	HungryRaidDB["options"][WodHMId][RaidDiffcultyHeroic] = chkHMHeroic:GetChecked()
	HungryRaidDB["options"][WodHMId][RaidDiffcultyMythic] = chkHMMythic:GetChecked()
	HungryRaidDB["options"][WodBRFId].Selected = chkBRF:GetChecked()
	HungryRaidDB["options"][WodBRFId][RaidDiffcultyNormal] = chkBRFNormal:GetChecked()
	HungryRaidDB["options"][WodBRFId][RaidDiffcultyHeroic] = chkBRFHeroic:GetChecked()
	HungryRaidDB["options"][WodBRFId][RaidDiffcultyMythic] = chkBRFMythic:GetChecked()
	HungryRaidDB["options"][WodHFCId].Selected = chkHFC:GetChecked()
	HungryRaidDB["options"][WodHFCId][RaidDiffcultyNormal] = chkHFCNormal:GetChecked()
	HungryRaidDB["options"][WodHFCId][RaidDiffcultyHeroic] = chkHFCHeroic:GetChecked()
	HungryRaidDB["options"][WodHFCId][RaidDiffcultyMythic] = chkHFCMythic:GetChecked()

	HungryRaidDB["options"]["HungryRaid"]["Flasks"].Selected = chkFlasks:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Flasks"].EPValue = txtFlasksEPValue:GetText()
	
	HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected = chkFoods:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected100 = chkFoods100:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Foods"].Selected125 = chkFoods125:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Foods"].EPValue = txtFoodsEPValue:GetText()

	HungryRaidDB["options"]["HungryRaid"]["Potions"].Selected = chkPotions:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Potions"].EPValue = txtPotionsEPValue:GetText()

	HungryRaidDB["options"]["HungryRaid"]["PrePotions"].Selected = chkPrePotions:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["PrePotions"].EPValue = txtPrePotionsEPValue:GetText()

	HungryRaidDB["options"]["HungryRaid"]["Runes"].Selected = chkRunes:GetChecked()
	HungryRaidDB["options"]["HungryRaid"]["Runes"].EPValue = txtRunesEPValue:GetText()
end
