-- GetRaidRosterInfo(raidIndex)
-- /run local x, y = GetFullRaidList(); local z = select(1, x); print(z)
-- UnitClassification("unit") - Returns the classification of the specified unit (e.g., "elite" or "worldboss").

function MakeOptionsUI(panel)
	
	-----------------------------------------------------------------------------------------------------------------
	-- Raids to control
	-----------------------------------------------------------------------------------------------------------------
	local frmRaids = CreateNewOptionFrame(panel, "Select raids to control", "Raids")

	local chkHM = CreateNewCheckButton(frmRaids, "Highmaul", "HM")
	local chkHMNormal = CreateNewSubCheckButton(chkHM, "Normal", "HMNormal")
	local chkHMHeroic = CreateNewSubCheckButton(chkHM, "Heroic", "HMHeroic")
	local chkHMMythic = CreateNewSubCheckButton(chkHM, "Mythic", "HMMythic")

	local chkBRF = CreateNewCheckButton(frmRaids, "Blackrock Furnance", "BRF")
	local chkBRFNormal = CreateNewSubCheckButton(chkBRF, "Normal", "BRFNormal")
	local chkBRFHeroic = CreateNewSubCheckButton(chkBRF, "Heroic", "BRFHeroic")
	local chkBRFMythic = CreateNewSubCheckButton(chkBRF, "Mythic", "BRFMythic")

	local chkHFC = CreateNewCheckButton(frmRaids, "Hellfire Citadel", "HFC")
	local chkHFCNormal = CreateNewSubCheckButton(chkHFC, "Normal", "HFCNormal")
	local chkHFCHeroic = CreateNewSubCheckButton(chkHFC, "Heroic", "HFCHeroic")
	local chkHFCMythic = CreateNewSubCheckButton(chkHFC, "Mythic", "HFCMythic")

	-----------------------------------------------------------------------------------------------------------------
	-- Consumables to control
	-----------------------------------------------------------------------------------------------------------------
	local frmConsumables = CreateNewOptionFrame(panel, "Select consumambles to control", "Consumables")
	local titleEPValue = CreateTextColumn(frmConsumables, "EP Value", "EPValue")

	local chkFlasks = CreateNewCheckButton(frmConsumables, "Flasks", "Flasks")
	local txtFlasksEPValue = CreateEditBoxColumn(chkFlasks, "FlasksEPValue")

	local chkFoods = CreateNewCheckButton(frmConsumables, "Foods", "Foods")
	local chkFoods100 = CreateUniqueSubCheckButton(chkFoods, "100", "Foods100")
	local chkFoods125 = CreateUniqueSubCheckButton(chkFoods, "125", "Foods125")
	local txtFoodsEPValue = CreateEditBoxColumn(chkFoods, "FoodsEPValue")

	local chkPotions = CreateNewCheckButton(frmConsumables, "Potions", "Potions")
	local txtPotionsEPValue = CreateEditBoxColumn(chkPotions, "PotionsEPValue")

	local chkPrePotions = CreateNewCheckButton(frmConsumables, "Pre-Potions", "PrePotions")
	local txtPrePotionsEPValue = CreateEditBoxColumn(chkPotions, "PrePotionsEPValue")

	local chkRunes = CreateNewCheckButton(frmConsumables, "Runes", "Runes")
	local txtRunesEPValue = CreateEditBoxColumn(chkRunes, "RunesEPValue")
	
	if (EPGP == nil) then
		titleEPValue:Hide()
		txtFlasksEPValue:Hide()
		txtFoodsEPValue:Hide()
		txtPotionsEPValue:Hide()
		txtPrePotionsEPValue:Hide()
		txtRunesEPValue:Hide()
	end
	
	ResizeFrames(panel)
end

function MakeResultFrame()
	-----------------------------------------------------------------------------------------------------------------
	-- Base Frame
	-----------------------------------------------------------------------------------------------------------------
	local frame = CreateFrame("Frame", "frmResult", UIParent)
	frame:SetSize(665, 400)
	frame:SetPoint("CENTER", 0, 0)
	frame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetBackdropBorderColor(1,1,1,1)
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function(frame) frame:StartMoving() end)
	frame:SetScript("OnDragStop", function(frame) frame:StopMovingOrSizing() end)
	
	local lblResumeOfFight = CreateTextColumn(frame, "Hungry Raid - Resume of last fight", "ResumeOfFight")
	local lblPlayer = CreateTextColumn(frame, "Player", "Player")
	local lblFlask = CreateTextColumn(frame, "Flask", "Flask")
	local lblFood = CreateTextColumn(frame, "Food", "Food")
	local lblRune = CreateTextColumn(frame, "Rune", "Rune")
	local lblPrevPotion = CreateTextColumn(frame, "Prev. Potion", "PrevPotion")
	local lblFightPotion = CreateTextColumn(frame, "Fight Potion", "FightPotion")

	lblPlayer:SetFont("Fonts\\FRIZQT__.TTF", 12)
	lblFlask:SetFont("Fonts\\FRIZQT__.TTF", 12)
	lblFood:SetFont("Fonts\\FRIZQT__.TTF", 12)
	lblRune:SetFont("Fonts\\FRIZQT__.TTF", 12)
	lblPrevPotion:SetFont("Fonts\\FRIZQT__.TTF", 12)
	lblFightPotion:SetFont("Fonts\\FRIZQT__.TTF", 12)

	lblResumeOfFight:SetPoint("TOPLEFT", 10, -10)
	lblPlayer:SetPoint("TOPLEFT", 10, -30)
	lblFlask:SetPoint("TOPLEFT", 150, -30)
	lblFood:SetPoint("TOPLEFT", 250, -30)
	lblRune:SetPoint("TOPLEFT", 350, -30)
	lblPrevPotion:SetPoint("TOPLEFT", 450, -30)
	lblFightPotion:SetPoint("TOPLEFT", 550, -30)
	
	-----------------------------------------------------------------------------------------------------------------
	-- Add Player Method
	-----------------------------------------------------------------------------------------------------------------
	frame.AddPlayer = function(self, player, flask, food, rune, prevPotion, potion)
		if (self.Lines == nil) then
			self.innerFrame = CreateFrame("Frame", "frmPlayerInnerFrame", self)
			self.List:SetScrollChild(self.innerFrame)
			-- self.innerFrame:SetAllPoints()
			self.innerFrame:SetSize(600, 600)
			self.Lines = {}
		end
		local qtd = table.getn(self.Lines) + 1
		self.Lines[qtd] = {}
		self.Lines[qtd].Player = CreateFrame("Frame", "frmPlayer" .. player, self.innerFrame)
		
		-- self.List:SetScrollChild(self.Lines[qtd].Player)

		self.Lines[qtd].Player:SetSize(600, 20)
		
		self.Lines[qtd].Player.Name = CreateLineText(self.Lines[qtd].Player, player)
		self.Lines[qtd].Player.Name:SetPoint("TOPLEFT", 10, 0)

		if (flask) then
			self.Lines[qtd].Player.Flask = CreateLineText(self.Lines[qtd].Player, "Used")
		else
			self.Lines[qtd].Player.Flask = CreateLineText(self.Lines[qtd].Player, "Not Used")
			self.Lines[qtd].Player.Flask:SetTextColor(1, 0, 0, 1)
		end
		self.Lines[qtd].Player.Flask:SetPoint("TOPLEFT", 150, 0)

		if (food) then
			self.Lines[qtd].Player.Food = CreateLineText(self.Lines[qtd].Player, "Used")
		else
			self.Lines[qtd].Player.Food = CreateLineText(self.Lines[qtd].Player, "Not Used")
			self.Lines[qtd].Player.Food:SetTextColor(1, 0, 0, 1)
		end
		self.Lines[qtd].Player.Food:SetPoint("TOPLEFT", 250, 0)

		if (rune) then
			self.Lines[qtd].Player.Rune = CreateLineText(self.Lines[qtd].Player, "Used")
		else
			self.Lines[qtd].Player.Rune = CreateLineText(self.Lines[qtd].Player, "Not Used")
			self.Lines[qtd].Player.Rune:SetTextColor(1, 0, 0, 1)
		end
		self.Lines[qtd].Player.Rune:SetPoint("TOPLEFT", 350, 0)

		if (prevPotion) then
			self.Lines[qtd].Player.PrevPotion = CreateLineText(self.Lines[qtd].Player, "Used")
		else
			self.Lines[qtd].Player.PrevPotion = CreateLineText(self.Lines[qtd].Player, "Not Used")
			self.Lines[qtd].Player.PrevPotion:SetTextColor(1, 0, 0, 1)
		end
		self.Lines[qtd].Player.PrevPotion:SetPoint("TOPLEFT", 450, 0)

		if (potion) then
			self.Lines[qtd].Player.Potion = CreateLineText(self.Lines[qtd].Player, "Used")
		else
			self.Lines[qtd].Player.Potion = CreateLineText(self.Lines[qtd].Player, "Not Used")
			self.Lines[qtd].Player.Potion:SetTextColor(1, 0, 0, 1)
		end
		self.Lines[qtd].Player.Potion:SetPoint("TOPLEFT", 550, 0)

		self.Lines[qtd].Player:SetPoint("TOPLEFT", 0, (-20 * qtd) + 10)

	end

	-----------------------------------------------------------------------------------------------------------------
	-- List Frame
	-----------------------------------------------------------------------------------------------------------------
	frame.List = CreateFrame("ScrollFrame", "frmResultList", frame)
	frame.List:SetSize(630, 320)
	frame.List:SetPoint("TOPLEFT", 5, -45)
	frame.List:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	frame.List:SetBackdropColor(0,0,0,1)
	frame.List:SetBackdropBorderColor(1,1,1,1)

	-----------------------------------------------------------------------------------------------------------------
	-- ScrollBar
	-----------------------------------------------------------------------------------------------------------------
	local sldResultList = CreateFrame("Slider", "sldResultList", frame.List, "UIPanelScrollBarTemplate")
	sldResultList:SetPoint("TOPLEFT", frame.List, "TOPRIGHT", 4, -16)
	sldResultList:SetPoint("BOTTOMLEFT", frame.List, "BOTTOMRIGHT", 4, 16) 	
	sldResultList:SetMinMaxValues(1, 200)
	sldResultList:SetValueStep(1) 
	sldResultList.scrollStep = 1 
	sldResultList:SetValue(0) 
	sldResultList:SetWidth(16) 
	sldResultList:SetScript("OnValueChanged", function (self, value)
		self:GetParent():SetVerticalScroll(value) 
	end) 
	local scrollbg = sldResultList:CreateTexture(nil, "BACKGROUND") 
	scrollbg:SetAllPoints(sldResultList) 
	scrollbg:SetTexture(0.2, 0.2, 0.2, 0.4) 
	
	-----------------------------------------------------------------------------------------------------------------
	-- btnReportAndApply Button
	-----------------------------------------------------------------------------------------------------------------
	local leftPosStartButtons = 5
	if (EPGP ~= nil) then
		local btnReportAndApply = CreateFrame("Button", "btnReportAndApply", frame, "UIPanelButtonTemplate")
		-- local btnReportAndApply = CreateFrame("Button", "btnReportAndApply", frame, "SecureActionButtonTemplate")
		btnReportAndApply:SetSize(130, 30)
		btnReportAndApply:SetPoint("TOPLEFT", leftPosStartButtons, -365)
		btnReportAndApply:SetText("Report and Credit")
		btnReportAndApply:SetScript("OnClick", function() 
			CreditEP()
			ReportEP()
		end)
		SetButtonEnabled(btnReportAndApply)
		leftPosStartButtons = leftPosStartButtons + 130
	end

	-----------------------------------------------------------------------------------------------------------------
	-- btnReport Button
	-----------------------------------------------------------------------------------------------------------------
	local btnReport = CreateFrame("Button", "btnReport", frame, "UIPanelButtonTemplate")
	btnReport:SetSize(130, 30)
	btnReport:SetPoint("TOPLEFT", leftPosStartButtons, -365)
	btnReport:SetText("Report")
	btnReport:SetScript("OnClick", function() 
		ReportEP()
	end)
	leftPosStartButtons = leftPosStartButtons + 130

	-----------------------------------------------------------------------------------------------------------------
	-- btnCancel Button
	-----------------------------------------------------------------------------------------------------------------
	local btnCancel = CreateFrame("Button", "btnCancel", frame, "UIPanelButtonTemplate")
	btnCancel:SetSize(130, 30)
	btnCancel:SetPoint("TOPLEFT", leftPosStartButtons, -365)
	btnCancel:SetText("Cancel")
	btnCancel:SetScript("OnClick", function() 
		frmResult:Hide(); 
	end)
	leftPosStartButtons = leftPosStartButtons + 130

	frmResult:Show()
	
	return frame
end

function SetButtonEnabled(btn)
	if (btn ~= nil) then
		if (EPGP:CanIncEPBy("Button", 1)) then
			btn:SetEnabled(true)
		else
			btn:SetEnabled(false)
		end

		C_Timer.After(0.1, function() SetButtonEnabled(btn) end)
	end
end

function CreateLineText(frame, str) 
	local text = frame:CreateFontString("lblPlayer"..str, "GameFontNormal")
	text:SetFont("Fonts\\FRIZQT__.TTF", 12)
	text:SetTextColor(0, 1, 0, 1)
	text:SetPoint("TOPLEFT", -50, 0)
	-- text:SetSize(200, 20)
	text:SetText(str)
	
	return text
end

function CreateNewOptionFrame(panel, title, name)
	local frame = CreateFrame("Frame", "frm"..name, panel)
	frame:SetSize(300, 500)
	frame:SetPoint("TOPLEFT", 20, -30)
	frame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetBackdropBorderColor(1,1,1,1)

	frame.text = frame:CreateFontString("title"..name, "GameFontNormal")
	frame.text:SetFont("Fonts\\FRIZQT__.TTF", 18)
	frame.text:SetTextColor(0.85, 0.85, 0.00, 1)
	frame.text:ClearAllPoints()
	frame.text:SetPoint("TOPLEFT", 20, -10)
	frame.text:SetText(title)
	
	return frame
end

function CreateTextColumn(frame, title, name)
	frame.text = frame:CreateFontString("lbl"..name, "GameFontNormal")
	frame.text:SetFont("Fonts\\FRIZQT__.TTF", 18)
	frame.text:SetTextColor(0.85, 0.85, 0.00, 1)
	frame.text:ClearAllPoints()
	frame.text:SetPoint("TOPLEFT", 470, -10)
	frame.text:SetText(title)
	
	return frame.text
end

function CreateEditBoxColumn(frame, name)
	local editBox = CreateFrame("EditBox", "txt"..name, frame, "InputBoxTemplate")
	editBox:SetPoint("TOPLEFT", 50, -5)
	editBox:SetHeight(19)
	editBox:SetWidth(40)
	editBox:SetAutoFocus(false)
	editBox:SetNumeric(true)
	editBox:SetMaxBytes(4)
	editBox:SetJustifyH("CENTER")
	editBox:SetToplevel(true)
	
	return editBox
end

function CreateNewCheckButton(frame, label, name)
	local check = CreateFrame("CheckButton", "chk"..name, frame, "ChatConfigCheckButtonTemplate");
	check:SetPoint("TOPLEFT", 20, -30);
	check.tooltip = label;
	-- check:SetSize(20, 20)
	
	check.text = check:CreateFontString("lbl"..name, "GameFontNormal")
	check.text:SetFont("Fonts\\FRIZQT__.TTF", 12)
	-- check.text:SetTextColor(0.85, 0.85, 0.85, 1)
	check.text:ClearAllPoints()
	check.text:SetPoint("TOPLEFT", 25, -5)
	check.text:SetText(label)
	check:SetScript("OnClick", 
		function()
			CheckButtonClicked(check)
		end
	);

	
	return check
end

function CreateUniqueSubCheckButton(frame, label, name)
	local check = CreateNewSubCheckButton(frame, label, name)
	
	check:SetScript("OnClick", 
		function()
			UniqueCheckButtonClicked(check)
		end
	);

	return check
end

function CreateNewSubCheckButton(frame, label, name)
	local check = CreateFrame("CheckButton", "chk"..name, frame, "ChatConfigCheckButtonTemplate");
	check:SetPoint("TOPLEFT", 200, 0);
	check.tooltip = label;
	
	check.text = check:CreateFontString("lbl"..name, "GameFontNormal")
	check.text:SetFont("Fonts\\FRIZQT__.TTF", 12)
	check.text:ClearAllPoints()
	check.text:SetPoint("TOPLEFT", 25, -5)
	check.text:SetText(label)
	check:SetHitRectInsets(0, -80, 0, 0) 
	
	return check
end

function UniqueCheckButtonClicked(check)
	local kids = { check:GetParent():GetChildren() }
	for _, child in ipairs(kids) do
		if (child:GetObjectType() == "CheckButton" and child ~= check) then
			child:SetChecked(false)
		end
	end
end

function CheckButtonClicked(check)
	local kids = { check:GetChildren() }

	if (check:GetChecked()) then
		for _, child in ipairs(kids) do
			child:Show()
		end
	else
		for _, child in ipairs(kids) do
			child:Hide()
			if (child:GetObjectType() == "CheckButton") then
				child:SetChecked(false)
			end
		end
	end
end

function ResizeFrames(frame)
	local kids = { frame:GetChildren() }
	local x, y = 20, -40
	
	for _, child in ipairs(kids) do
		child:SetPoint("TOPLEFT", x, y)
		if (child:GetObjectType() == "Frame") then
			ResizeFrames(child)
			y = y - child:GetHeight()
		else
			ResizeSubCheckButton(child)
			y = y -35
		end
	end

	if (frame:GetObjectType() == "Frame") then
		frame:SetSize(580, (y * -1))
	end
end

function ResizeSubCheckButton(check)
	local kids = { check:GetChildren() }
	local x, y = 250, 0
	for _, child in ipairs(kids) do
		if (child:GetObjectType() == "EditBox") then
			ResizeEditBox(child)
		else
			child:SetPoint("TOPLEFT", x, y)
			x = x + 100
		end
	end
end

function ResizeEditBox(editBox)
	editBox:SetPoint("TOPLEFT", 450, 0)
end

function SetFramesVisibility(frame)
	local kids = { frame:GetChildren() }
	
	for _, child in ipairs(kids) do
		if (frame:GetObjectType() == "CheckButton") then
			if (frame:GetChecked()) then
				child:Show()
			else
				child:Hide()
			end
		end
		if (child:GetObjectType() == "EditBox") then
			child:SetCursorPosition(0)
		end

		SetFramesVisibility(child)
	end
end